stages:
  - publish
  - scan

variables:
  SQUID_VERSION: '3'
  DOCKER_DRIVER: overlay2

build-image-pr:
  image: docker:latest
  before_script: ['docker info']
  services: ['docker:dind']
  stage: publish
  script:
    - docker build -t $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA --label org.label-schema.vcs-url=$CI_COMMIT_SHA .
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
  tags: [docker]
  except: [master, tags]

build-image:
  image: docker:latest
  before_script: ['docker info']
  services: ['docker:dind']
  stage: publish
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker build -t $CI_REGISTRY_IMAGE:$SQUID_VERSION-$CI_PIPELINE_ID --label org.label-schema.vcs-ref=$CI_COMMIT_SHA .
    - docker tag $CI_REGISTRY_IMAGE:$SQUID_VERSION-$CI_PIPELINE_ID $CI_REGISTRY_IMAGE:$SQUID_VERSION
    - docker tag $CI_REGISTRY_IMAGE:$SQUID_VERSION-$CI_PIPELINE_ID $CI_REGISTRY_IMAGE:latest
    - docker tag $CI_REGISTRY_IMAGE:$SQUID_VERSION-$CI_PIPELINE_ID $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
    - docker push $CI_REGISTRY_IMAGE:$SQUID_VERSION-$CI_PIPELINE_ID
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
    - docker push $CI_REGISTRY_IMAGE:$SQUID_VERSION
    - docker push $CI_REGISTRY_IMAGE:latest
  only: [master, tags]
  tags: [docker]

sast:container:
  image: docker:latest
  stage: scan
  variables:
    CI_APPLICATION_REPOSITORY: $CI_REGISTRY_IMAGE
    CI_APPLICATION_TAG: $CI_COMMIT_SHA
  allow_failure: true
  services:
    - docker:dind
  script:
    - docker run -d --name db arminc/clair-db:latest
    - docker run -p 6060:6060 --link db:postgres -d --name clair arminc/clair-local-scan:v2.0.5
    - apk add -U wget ca-certificates
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY
    - docker pull ${CI_APPLICATION_REPOSITORY}:${CI_APPLICATION_TAG}
    - wget https://github.com/arminc/clair-scanner/releases/download/v8/clair-scanner_linux_amd64
    - mv clair-scanner_linux_amd64 clair-scanner
    - chmod +x clair-scanner
    - touch clair-whitelist.yml
    - ./clair-scanner -c http://docker:6060 --ip $(hostname -i) -r gl-sast-container-report.json -l clair.log -w clair-whitelist.yml ${CI_APPLICATION_REPOSITORY}:${CI_APPLICATION_TAG} || true
  artifacts:
    paths: [gl-sast-container-report.json]
